<template>
  <div class="signIn_wrapper signIn_wrapper-step">
    <div class="signIn_inner flex flex_column flex-middle">
      <BInput
        disabled
        label="Used to sign in"
        :error="error"
        :maxLength="maxlength"
        @refresh="() => {sendRefresh();checkOrGenerateName('')}"
        v-model="accountNameToSignIn"></BInput>
      <Btn
        :disabled="disabled"
        @click="nextStep">{{$t('authorization.continueTo')}} 2
      </Btn>
      <div class="flex flex-middle flex-center signIn-hr">
        <div class="signIn-divider"></div>
        <div class="signIn-divider-text">-{{$t('common.or')}}-</div>
        <div class="signIn-divider"></div>
      </div>
      <Btn
        qr
        @click="loginWith">{{$t('authorization.loginWith')}}
        <template slot="img">
          <div class="signIn-btn-img-wrapper">
            <img
              class="signIn-btn-img"
              src="~/static/icons/signin/key.png"
              alt="">
            <div class="signIn-btn-key">{{$t('authorization.login_with')}}</div>
          </div>
        </template>
      </Btn>
      <Btn
        scatter
        @click="loginScatter">{{$t('authorization.loginWith')}}
        <template slot="img">
          <div class="signIn-btn-img-wrapper ml-10">
            <img
              class="signIn-btn-img"
              src="~/static/icons/signin/scatter.png"
              alt="">
          </div>
        </template>
      </Btn>
      <!-- https://magic-desolver.lynxwallet.io/desktop/lynxwallet:apps_eosbluebet  -->
      <a
        v-if="false"
        href="https://lynxchain.io/download"
        data-app-link="intent://magic.lynxwallet.io/jFHy">
        <Btn
          lynx>
          {{$t('authorization.loginWith')}}
          <template slot="img">
            <div class="signIn-btn-img-wrapper">
              <img
                class="signIn-btn-img"
                src="~/static/icons/signin/lynx.png"
                alt="">
            </div>
          </template>
        </Btn>
      </a>
    </div>
    <Loader
      ref="loader"
      :loadFunc="accountCreated">{{loadingText}}
    </Loader>
  </div>
</template>

<script>
  import Btn from '~/components/UI/BtnSign';
  import BInput from './Input';

  import {Wallet} from "~/services/wallet";
  import Loader from '~/components/UI/Loader';

  import notification
    from '~/components/UI/Notification/main.js';

  import deeplinker from '@codexteam/deeplinker';
  import mixin_signIn from "./mixin_utils";

  export default {
    name: "TheStep1",
    mixins: [mixin_signIn],
    data() {
      return {
        disabled: false,
        error: false,
        maxlength: 12,
        loadingText: 'Creating...',
        accountCreated: () => false,
        accountNameToSignIn: ''
      }
    },
    components: {
      Btn,
      BInput,
      Loader
    },
    computed: {
      passedSteps() {
        return this.$store.state.signIn.passed;
      },
    },
    methods: {
      sendRefresh() {
        this.ga('refresh');
      },
      loginLynx() {
        const lynx = this.$refs['lynx'];
        deeplinker.click(lynx.$el);
      },
      loginWith() {
        this.ga('logk');
        this.$store.commit('signIn/SET_STEP', {
          key: 'step1',
          value: true
        });
        this.$store.commit('signIn/SET_STEP', {
          key: 'step2',
          value: true
        });
        this.$emit('nextStep');
        this.$emit('nextStep');
        this.$nextTick(_ => {
          this.$store.commit('signIn/SET_STEP', {
            key: 'step1',
            value: false
          });
          this.$store.commit('signIn/SET_STEP', {
            key: 'step2',
            value: false
          });
        })
      },
      async checkOrGenerateName(name = this.accountNameToSignIn) {
        this.disabled = true;
        this.error = false;
        try {
          this.accountNameToSignIn = await this.mixin_checkOrGenerateName(name, this.maxlength);
        } catch (e) {
          this.error = true;
        }
        this.disabled = false;
      },
      async loginScatter() {
        this.ga('logs');
        await this.$store.dispatch('common/changeGameType', false);
        this.loadingText = this.$t('authorization.checking');
        this.$refs['loader'].show();
        try {
          await this.$store.dispatch('wallet/loginScatter');
          this.$refs['loader'].close();
          this.$root.$refs['headerTop'].showAuth(false);
        } catch (e) {
          notification.warning({
            message: e.message,
          });
          this.$refs['loader'].close();
        }
      },
      nextStep() {
        this.$store.dispatch('signIn/generateMnemonic');
        this.disabled = true;
        this.ga('con');
        Wallet.getKeys().then(keys => {
          this.$store.commit('signIn/SET_ACCOUNT_NAME', this.accountNameToSignIn);
          this.$store.commit('signIn/SET_STEP', {
            key: 'step1',
            value: true
          });
          this.$emit('nextStep');
          this.disabled = false;
        });
      }
    },
    mounted() {
      this.checkOrGenerateName();
      deeplinker.init();
      this.loadingText = this.$t('authorization.creating');
    }
  }
</script>
